/**
 * Created by 曾建峰 on 2017-07-11.
 * 芯与推送服务
 */
(function(){

    window.XINYU_PUSH = {
        // websocket 对象
        options : {},
        ws : null,
        // 监听回调
        listener : {},
        lastHeartTime : 0,
        internalV : null,
        // 连接
        connect : function (url,name) {
            this.options.url = url;
            this.options.name = name;
            this.ws = new WebSocket(url+"/"+name);
            // this.ws.binaryType = "arraybuffer";
            var that = this;
            this.ws.onopen = function(){
                that.onopen(that);
            };
            this.ws.onmessage = function(evt){
                that.onmessage(evt,that);
            } ;
            this.ws.onclose = function() {
                that.onclose(that);
            }

        },
        onopen : function(that) {
            that.lastHeartTime = new Date().getTime();
            console.log("[XINYU_PUSH] connect success, xinyupush server : " + that.options.url + " success. your name is "+that.options.name);

            for(var k in that.listener) {
                var subArray = k.split("&");
                that.subscribe(subArray[0],subArray[1],that.listener[k]);
            }


            // 开启定时

            if (that.internalV != undefined) {

                clearInterval(that.internalV);
            }

            that.internalV = setInterval(function(){
                that.checkConnect(that);
            },5000);
        },

        onerror : function(that) {
            console.log("[XINYU_PUSH] connect error, xinyupush server : " + that.options.url + " success. your name is "+that.options.name);
        },

        onmessage : function (evt,that) {
            // var this = this;
            var received_msg = evt.data;
            if(evt.data instanceof ArrayBuffer){
                received_msg = String.fromCharCode.apply(null, new Uint8Array(received_msg));
            }


            var obj = JSON.parse(received_msg);


            if (obj.message.action == 'SUBSCRIBE'){

                console.log("[XINYU_PUSH] subscribe success. key is " + obj.message.command+"&"+obj.message.destination);

            } else if (obj.message.action == 'CANCEL') {

                console.log("[XINYU_PUSH] unsubscribe success. key is " + obj.message.command+"&"+obj.message.destination);

            } else if (obj.message.action == 'HEART') {

                that.lastHeartTime = new Date().getTime();

            } else if (obj.message.action == 'PUSH') {
                var cb = that.listener[obj.message.command+"&"+obj.message.destination];
                if (cb){
                    cb(obj.data);
                } else {

                    cb = that.listener[obj.message.command+"&*"]

                    if (cb) {
                        cb(obj.data);
                    } else {
                        console.log("[XINYU_PUSH] action : " + obj.message.action + " have no listener");
                    }

                }
            }

            // if (obj.)

        },
        onclose : function (that) {
            console.log("[XINYU_PUSH] connect xinyupush server : " + that.options.url + " closed. your name is "+that.options.name);
        },
        // 连接检查
        checkConnect : function (that) {
            var obj = {action:"HEART"};
            that.ws.send(JSON.stringify(obj));
            // 上次的时间距离现在多久
            var now = new Date().getTime();
            // 30秒无反应，则重连
            if ( now - that.lastHeartTime > 15000) {
                console.log("[XINYU_PUSH] loss connect , try reconnect");
                that.lastHeartTime = now;

                if (that.ws != null) {
                    that.ws.close();
                    that.connect(that.options.url,that.options.name);
                }

            }
        },
        /**
         * 消息訂閱
         * @param command 類型
         * @param destination 目的
         * @param cb 回调方法 对应的
         */
        subscribe : function (command,destination,cb) {
            console.log("[XINYU_PUSH] subscribe. key is " + command+"&"+destination);
            this.listener[command+"&"+destination] = cb;
            if (this.ws.readyState == 1) {
                var obj = {command:command,destination:destination,action:"SUBSCRIBE"};
                this.ws.send(JSON.stringify(obj));
            }
        },
        /**
         * 取消订阅
         * @param command
         * @param destination
         */
        unsubscribe : function (command,destination) {
            console.log("[XINYU_PUSH] unsubscribe. key is " + command+"&"+destination);
            delete this.listener[command+"&"+destination];
            var obj = {command:command,destination:destination,action:"CANCEL"};
            this.ws.send(JSON.stringify(obj));
        },
    }

})();